%
% D:\Studies\NHP\Card3\cal_angulations_stat.m
% 
%   Calculate the std, plot the range of angulation deviation.
% 
% 
% 
% % % % % % % % % % % % % % % % % % 
% Modified by Richard Tai-Chiu Hsung
% Nov 20, 2013.
%
function [err_HF, err_VF, mean_HF, mean_VF] = cal_angulations_stat(All_HuvecF, All_VuvecF, comments_pre)


direction = -2*((All_HuvecF(:,1)>0)-0.5)*ones(1,3);
All_HuvecF2 = All_HuvecF.*direction;
angle_HOnXY = atan2d(All_HuvecF2(:,1), All_HuvecF2(:,2));
angle_HOnXZ = atan2d(All_HuvecF2(:,1), All_HuvecF2(:,3));
% angle_HuvecF = acosd(All_HuvecF.*direction);
angle_HuvecF = [angle_HOnXZ angle_HOnXY];

direction = -2*((All_VuvecF(:,2)>0)-0.5)*ones(1,3);
All_VuvecF2 = All_VuvecF.*direction;
angle_VOnYX = atan2d(All_VuvecF2(:,2), All_VuvecF2(:,1));
angle_VOnYZ = atan2d(All_VuvecF2(:,2), All_VuvecF2(:,3));
% angle_VuvecF = acosd(All_VuvecF.*direction);
angle_VuvecF = [angle_VOnYZ angle_VOnYX]

mean_VF = mean(angle_VuvecF,1);
mean_HF = mean(angle_HuvecF,1);

nsample = size((angle_VuvecF),1);
err_VF = angle_VuvecF - (ones(nsample,1)*mean_VF);
err_HF = angle_HuvecF - (ones(nsample,1)*mean_HF);


mean_anglesF  =  [mean_VF(1) mean_VF(2) mean_HF(1)];
Cmean_anglesF =  [90 90 90]+mean_anglesF;

disp(['[' comments_pre '] Pitch Roll Yaw --------------------']);
disp('Mean of deviations to XYZ axes');
disp(Cmean_anglesF)
disp('STD of deviations');
disp(std([ angle_VuvecF(:,1) angle_VuvecF(:,2) angle_HuvecF(:,1)]))
disp('+ deviations');
disp(max([ err_VF(:,1) err_VF(:,2) err_HF(:,1)]))
disp('- deviations');
disp(min([ err_VF(:,1) err_VF(:,2) err_HF(:,1)]))


% % disp('PitchY RollY YawX RollX');
% res=[angle_VuvecF angle_HuvecF]+[ones(nsample,1)*[90 90 90 90] ];
% disp('Mean of deviations: PitchY RollY YawX RollX');
% mean(res)
% disp('STD of deviations: PitchY RollY YawX RollX');
% std(res)



% disp(['[' comments_pre '] Vertical line --------------------']);
% disp('Angle between [X Y Z] Axes (Roll, Roll, Pitch)');
% disp(angle_VuvecF)
% disp('Mean');
% disp(mean_VF)
% disp('STD');
% disp(std(angle_VuvecF))
% disp('Err V');
% disp((err_VF))
% 
% 
% 
% disp(['[' comments_pre '] Horizontal line --------------------']);
% disp('Angle between [X Y Z] Axes (Roll, Roll, Yaw)');
% disp(angle_HuvecF)
% disp('Mean');
% disp(mean_HF)
% disp('STD');
% disp(std(angle_HuvecF))
% disp('Err H');
% disp((err_HF))
% 
% % Mean pitch roll yaw angles
% mean_anglesF  =  [mean_VF(3) mean_VF(2) mean_HF(3)]
% Cmean_anglesF =  [90 180 90]-mean_anglesF

return

