%
% D:\Studies\NHP\mirror
% worker function for a round.
%
% 2. Fit the horizontal and vertical lines of two point clouds.
% 3. Calculate the Pitch Roll Yaw.
% 
% 
% 
% HSUNG Tai-Chiu, Richard.
% July 4, 2013.
function [Vuvec, Huvec] = compute_1PRYsq(vh, vv, figno)

bbx=[0 0 -5; 0 0 5];

All_Vuvec = [0 0 0];
All_Huvec = [0 0 0];
% r=0;
% for k=N0:N

   
	% Vertical
	vaxisv = vv;
	
	% Horizontal
	haxisv = vh;

    % Fit vertical axis!
    mean_vaxis = mean(vaxisv);

    % Range
    xxx = [vaxisv(:,1);haxisv(:,1)];
    yyy = [vaxisv(:,2);haxisv(:,2)];
    hlimit = ([min(xxx) max(xxx)]);
    vlimit = ([min(yyy) max(yyy)]);

    
    A=[vaxisv(:,1)-mean_vaxis(1) vaxisv(:,2)-mean_vaxis(2) vaxisv(:,3)-mean_vaxis(3)];
    [u,s,v]=svd(A);
%     diag(s);
%     Vunitvec=v(:,1)';

    % Find centroids of two patches
    p=1;m=1;
    for r=1:length(vv)
        if (vv(r,2)>mean_vaxis(2))
            vvp(p,:)=vv(r,:);
            p=p+1;
        else
            vvm(m,:)=vv(r,:);
            m=m+1;
        end
    end

    vctrs = [mean(vvp); mean(vvm)];
    if (figno>0)
        figure(figno);
        plot3(vctrs(:,1),vctrs(:,2),vctrs(:,3), 'ro');
        plot3(vctrs(:,1),vctrs(:,2),vctrs(:,3), 'r-');
    end
    vc=vctrs(2,:)-vctrs(1,:);
    Vunitvec = vc/sqrt(vc*vc');
    if (Vunitvec(2)<0)
        Vunitvec=-1*Vunitvec;
    end
%     Vunitvec 
%     v(:,1)'

%     scale_v = (vlimit-mean_vaxis(2))/Vunitvec(2);
%     theVPoints=[Vunitvec*scale_v(1); Vunitvec*scale_v(2)]+[mean_vaxis;mean_vaxis];
%     plot3(theVPoints(:,1),theVPoints(:,2),theVPoints(:,3), 'r-');
    Vuvec = Vunitvec;
%     All_Vuvec(r+1,:) = Vunitvec;
    


% Fit horizontal axis!
    mean_haxis = mean(haxisv);
    
    B=[haxisv(:,1)-mean_haxis(1) haxisv(:,2)-mean_haxis(2) haxisv(:,3)-mean_haxis(3)];
    [u,s,v]=svd(B);
%     diag(s)
%     Hunitvec=v(:,1)';

    p=1; m=1;
    for r=1:length(vh)
        if (vh(r,1)>mean_haxis(1))
            vhp(p,:)=vh(r,:);
            p=p+1;
        else
            vhm(m,:)=vh(r,:);
            m=m+1;
        end
    end

    hctrs = [mean(vhp); mean(vhm)];
    if (figno>0)
        figure(figno);
        plot3(hctrs(:,1),hctrs(:,2),hctrs(:,3), 'go');
        plot3(hctrs(:,1),hctrs(:,2),hctrs(:,3), 'g-');
    end
    hc=hctrs(2,:)-hctrs(1,:);
    Hunitvec = hc/sqrt(hc*hc');
    if (Hunitvec(2)<0)
        Hunitvec=-1*Hunitvec;
    end
%     Hunitvec
%     v(:,1)'

%     scale_h = (hlimit-mean_haxis(1))/Hunitvec(1);
%     theHPoints=[Hunitvec*scale_h(1); Hunitvec*scale_h(2)]+[mean_haxis;mean_haxis];
%     plot3(theHPoints(:,1),theHPoints(:,2),theHPoints(:,3), 'g-');
    Huvec = Hunitvec;
    
return




