%
% Load the mesh model of nhp board version 1: 4 squares.
% 
% Fit:
%   1. Compute princpal vector of each of the 2 patches.
%   2. Visualize them.
% 
% 
% Note:
%   Please make sure the PLY is saved with texture.
%   1. Vertical patches: 
% 
% Richard Hsung
% Nov 4, 2013.
% Oct 9, 2013.
%
function [vertex_h, vertex_v, para_g, para_usemtl] = extract_patches_obj(name_obj, name_tex,figno)

% name_ply
% [v,f,tX,tY,t,t2] = read_ply2([name_ply]);
% [pv,pf,ptX,ptY,pt,pt2] = read_ply2([name_ply]);
[v,f,normal,texcorrd, tX, tY, ftexi, fnmi, para_g, para_usemtl] = read_obj2(name_obj);
% [v,f,normal,texcorrd, tX, tY] = read_obj2(name_obj);
tex=imread([name_tex]);
[nrow,ncol,nc] = size(tex);
numv = length(v);

% Convert to L*ab color space.
illumination = 'd65_64';
tex_vec3 = double([reshape(tex(:,:,1),[],1) reshape(tex(:,:,2),[],1) reshape(tex(:,:,3),[],1)]);



%% Use RGB to classify
% tex_12 = tex_vec3(:,1)-tex_vec3(:,2);
% tex_13 = tex_vec3(:,1)-tex_vec3(:,3);
% tex_21 = tex_vec3(:,2)-tex_vec3(:,1);
% tex_23 = tex_vec3(:,2)-tex_vec3(:,3);
% %Red
% th=40;
% binv = reshape((tex_12>th).*(tex_12>th),nrow,ncol);
% bin_v = medfilt2(binv,[5,5]);
% %Green
% binh = reshape((tex_21>th).*(tex_23>th),nrow,ncol);
% bin_h = medfilt2(binh,[5,5]);

%% Use CIELAB color to 
tex_lab3 = xyz2lab(srgb2xyz(tex_vec3),illumination);
tex_LABL = reshape(tex_lab3(:,1),nrow,ncol);
tex_LABa = reshape(tex_lab3(:,2),nrow,ncol);
tex_LABb = reshape(tex_lab3(:,3),nrow,ncol);


tex_abtan = atan2(tex_LABb,tex_LABa);
tex_ababs = sqrt(tex_LABb.^2+tex_LABa.^2);

bin_v = medfilt2((tex_ababs>2).*(abs(tex_abtan-0.2)<0.4), [3,3]);
bin_h = medfilt2((tex_ababs>2).*(abs(tex_abtan-pi+0.6)<0.4), [3,3]);
% bin_v = medfilt2((tex_ababs>2).*(abs(tex_abtan-0.2)<0.4), [5,5]);
% bin_h = medfilt2((tex_ababs>2).*(abs(tex_abtan-pi+0.6)<0.4), [5,5]);

% % bin_h = medfilt2(medfilt2( (tex_LABa<-1).*(tex_LABb>0.5) , [9,9]), [9,9]);
% % bin_v = medfilt2(medfilt2( (tex_LABa>1.5).*abs(tex_LABb<1.) , [9,9]), [9,9]);
% bin_h = medfilt2(medfilt2( (tex_LABa<-1).*(tex_LABb>0.5) , [5,5]), [5,5]);



[Nrow,Ncol] = size(bin_v);
Srow = Nrow-1;
Scol = Ncol-1;

% figure
% imshow(tex);
% figure
% imshow([bin_h;bin_v]);

% Extract vertical patch
uh=1; uv=1;
for k=1:numv
    c = floor(tX(k)*Scol)+1;
    r = floor((1-tY(k))*Srow)+1;
    % pp(k,:)=[r c];
        if (bin_h(r,c) > 0.5)
        vertex_h(uh,:)=v(k,:);
        uh=uh+1;
    end
    if (bin_v(r,c) > 0.5)
        vertex_v(uv,:)=v(k,:);
        uv=uv+1;
    end
end

if (figno<1)
    return;
end

figure(figno);
hold on;
plot3(vertex_h(:,1), vertex_h(:,2),vertex_h(:,3),'g.')
xlabel('x'); ylabel('y'); zlabel('z'); grid on
hold on;
plot3(vertex_v(:,1), vertex_v(:,2),vertex_v(:,3),'r.')


