% spnhpoc_homo2euler
% 
% Convert the MLMatrix44 into euler angles
% 
% Input:
%   1. A mlp file which contain alignment matrices.
% Output:
%   1. The 3 euler angles.
% 
% 
% Hsung Tai-Chiu, Richard.
% Nov 19, 2014
% 
function main_he(fname)
%%
% addpath 'D:\tch\ml\toolbox_graph'
% addpath 'D:\tch\ml\colortoolbox_v1_1'

%%
show_vermsg();

%%
fprintf('\nLooking for MLMatrix44 in file %s ...\n', fname);

xDoc = xmlread(fname);
mtr = xDoc.getElementsByTagName('MLMatrix44');
len = mtr.getLength;

L=diag([-1 -1 1 1]);
R=diag([-1 -1 1 1]);

for k=1:len
    this_elm = mtr.item(k-1);
    the_item = this_elm.getFirstChild.getData;
    trans=str2num(the_item);
    fprintf('MLMatrix44 #%d\n', k-1);
    m00 = trans(1,1);
    m01 = trans(1,2);
    m02 = trans(1,3);

    m10 = trans(2,1);
    m11 = trans(2,2);
    m12 = trans(2,3);

    m20 = trans(3,1);
    m21 = trans(3,2);
    m22 = trans(3,3);
    % y-z phi
    pitch = atan2d(m22,m21)
    % x-y psi
    roll  = atan2d(-m10,m00)
    % x-z theta
    yaw   = asind(m20)

end

fprintf('Done\n\n');
exitcode = 0;
return



function show_vermsg()
fprintf('\nSP-NHP Extract euler anlges\n\n');
fprintf('\nspnhpoc_homo2euler input_mlp_file\n');
fprintf('Author: Richard Tai-Chiu Hsung\n');
fprintf('Faculty of Dentistry (OMFS), The University of Hong Kong\n');
fprintf('email: tchsung@hku.hk\n');
fprintf('Last update: Nov 19, 2014\n');
return